"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addItemAnalyses = addItemAnalyses;
exports.addQuizAnalysis = addQuizAnalysis;
exports.markQuizAnalysisNotFound = markQuizAnalysisNotFound;
exports.markItemAnalysisNotFound = markItemAnalysisNotFound;
exports.toggleItemAnalysisRowExpanded = toggleItemAnalysisRowExpanded;

var _constants = require("@instructure/quiz-common/lib/constants");

function addItemAnalyses(itemAnalyses) {
  return {
    type: _constants.ADD_ITEM_ANALYSES,
    payload: itemAnalyses
  };
}

function addQuizAnalysis(quizAnalysis) {
  return {
    type: _constants.ADD_QUIZ_ANALYSIS,
    payload: quizAnalysis
  };
}

function markQuizAnalysisNotFound(quizId) {
  return {
    type: _constants.QUIZ_ANALYSIS_NOT_FOUND,
    payload: quizId
  };
}

function markItemAnalysisNotFound(itemId) {
  return {
    type: _constants.ITEM_ANALYSIS_NOT_FOUND,
    payload: itemId
  };
}

function toggleItemAnalysisRowExpanded(itemId) {
  return {
    payload: itemId,
    type: _constants.TOGGLE_ITEM_ANALYSIS_EXPANDED
  };
}