"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.uploadStatus = exports.setAltText = exports.receiveFile = exports.clearFiles = exports.clearAltText = void 0;

var _constants = require("@instructure/quiz-common/lib/constants");

var clearAltText = function clearAltText() {
  return {
    type: _constants.CLEAR_ALT_TEXT
  };
};

exports.clearAltText = clearAltText;

var clearFiles = function clearFiles() {
  return {
    type: _constants.CLEAR_FILES
  };
};

exports.clearFiles = clearFiles;

var receiveFile = function receiveFile(file) {
  return {
    type: _constants.FILE_RECEIVED,
    payload: {
      file: file
    }
  };
};

exports.receiveFile = receiveFile;

var setAltText = function setAltText(altText) {
  return {
    type: _constants.SET_ALT_TEXT,
    payload: {
      altText: altText
    }
  };
};

exports.setAltText = setAltText;

var uploadStatus = function uploadStatus(status) {
  return {
    type: _constants.FILE_UPLOAD_STATUS,
    payload: {
      status: status
    }
  };
};

exports.uploadStatus = uploadStatus;