"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generator;

var _color = require("@instructure/ui-themeable/lib/utils/color");

function generator(_ref) {
  var colors = _ref.colors,
      spacing = _ref.spacing,
      typography = _ref.typography,
      borders = _ref.borders,
      breakpoints = _ref.breakpoints,
      transitions = _ref.transitions;
  return {
    sidebarWidthClosed: spacing.xxLarge,
    sidebarWidthOpen: '22rem',
    sidebarBackgroundColor: colors.white,
    sidebarBorderWidth: borders.widthSmall,
    sidebarBorderColor: colors.tiara,
    sidebarColor: colors.oxford,
    sidebarZIndex: '5555',
    sidebarTransitionDuration: transitions.duration,
    infoHolderFontSize: typography.fontSizeXSmall,
    infoHolderBorderWidth: borders.widthSmall,
    infoHolderBorderColor: colors.tiara,
    infoHolderPadding: spacing.small,
    actionableInfoHoverBorderColor: colors.electric,
    actionableInfoBorderWidth: borders.widthLarge,
    questionNavigatorPadding: spacing.xxxSmall,
    headerSpacingPadding: "".concat(spacing.small, " ").concat(spacing.xSmall),
    pinnedSectionBackgroundColor: colors.porcelain,
    sidebarHeaderBorderWidth: borders.widthSmall,
    sidebarHeaderBorderColor: colors.tiara,
    descriptionFontSize: typography.fontSizeXSmall,
    descriptionFontColor: colors.slate,
    phoneBreakPoint: "max-width: ".concat(breakpoints.medium),
    focusBorderColor: colors.brand,
    focusOutlineColor: (0, _color.alpha)(colors.brand, 50)
  };
}

generator.canvas = function (variables) {
  return {
    focusBorderColor: variables['ic-brand-primary'],
    focusOutlineColor: (0, _color.alpha)(variables['ic-brand-primary'], 50)
  };
};