"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = require("immutable");

var _constants = require("@instructure/quiz-common/lib/constants");

var defaultState = (0, _immutable.fromJS)({
  scoreReconciliation: 'new_score'
});

var _default = function _default() {
  var state = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : defaultState;
  var action = arguments.length > 1 ? arguments[1] : void 0;

  switch (action.type) {
    case _constants.REGRADE_TOGGLE_REGRADING_EDIT_MODE:
      if (state.get('regradeEditModeKey') === action.payload) {
        return state.remove('regradeEditModeKey');
      } else {
        return state.set('regradeEditModeKey', action.payload);
      }

    case _constants.REGRADE_SET_SCORE_RECONCILIATION:
      return state.set('scoreReconciliation', action.payload);

    case _constants.REGRADE_SET_PAYLOAD:
      return state.set('regradingPayload', action.payload);

    default:
      return state;
  }
};

exports.default = _default;