"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _immutable = require("immutable");

var _keyBy = _interopRequireDefault(require("lodash/keyBy"));

var _constants = require("@instructure/quiz-common/lib/constants");

var addSessionItemResults = function addSessionItemResults(state, sessionItemResults) {
  var sessionItemResultsHash = (0, _keyBy.default)(sessionItemResults, 'id');
  return state.merge((0, _immutable.fromJS)(sessionItemResultsHash));
};

var _default = function _default() {
  var state = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : (0, _immutable.Map)();
  var action = arguments.length > 1 ? arguments[1] : void 0;

  switch (action.type) {
    case _constants.ADD_SESSION_ITEM_RESULTS:
      return addSessionItemResults(state, action.payload);

    default:
      return state;
  }
};

exports.default = _default;