"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _keyBy = _interopRequireDefault(require("lodash/keyBy"));

var _immutable = require("immutable");

var _constants = require("@instructure/quiz-common/lib/constants");

var addSessionItems = function addSessionItems(state, sessionItems) {
  var sessionItemsHash = (0, _keyBy.default)(sessionItems, 'id');
  return state.mergeDeep((0, _immutable.fromJS)(sessionItemsHash));
};

var defaultState = (0, _immutable.fromJS)({});

var _default = function _default() {
  var state = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : defaultState;
  var action = arguments.length > 1 ? arguments[1] : void 0;

  switch (action.type) {
    case _constants.ADD_SESSION_ITEMS:
      return addSessionItems(state, action.payload);

    default:
      return state;
  }
};

exports.default = _default;