"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.httpHeaders = exports.jwtHeader = exports.jsonHeaders = void 0;
var jsonHeaders = {
  Accept: 'application/json',
  'Content-Type': 'application/json'
};
exports.jsonHeaders = jsonHeaders;

var jwtHeader = function jwtHeader(token) {
  if (token) {
    return {
      Authorization: token,
      AuthType: 'Signature'
    };
  }
};

exports.jwtHeader = jwtHeader;

var httpHeaders = function httpHeaders(token) {
  return Object.assign({}, jsonHeaders, jwtHeader(token));
};

exports.httpHeaders = httpHeaders;