"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.interactionTypeMetadata = void 0;

var _IconPlus = _interopRequireDefault(require("@instructure/ui-icons/lib/Line/IconPlus"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

// TODO: Add correct icon file imports when they are in inst icons
// import MultipleChoiceIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MultipleAnswerIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import TrueOrFalseIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MatchingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import OrderingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import FillBlankIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import EssayIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
var interactionTypesIconDictionary = function interactionTypesIconDictionary(intType) {
  return {// TODO: Uncomment when we have the icons imported
    // 'choice': MultipleChoiceIcon,
    // 'multi-answer': MultipleAnswerIcon,
    // 'true-false': TrueOrFalseIcon,
    // 'matching': MatchingIcon,
    // 'ordering': OrderingIcon,
    // 'fill-blank': FillBlankIcon,
    // 'essay': EssayIcon
  }[intType.slug] || _IconPlus.default;
};

var interactionTypesNameDictionary = function interactionTypesNameDictionary(intType) {
  return {
    categorization: (0, _formatMessage.default)('Categorization'),
    choice: (0, _formatMessage.default)('Multiple Choice'),
    essay: (0, _formatMessage.default)('Essay'),
    'file-upload': (0, _formatMessage.default)('File Upload'),
    'fill-blank': (0, _formatMessage.default)('Fill in the Blank'),
    formula: (0, _formatMessage.default)('Formula'),
    'hot-spot': (0, _formatMessage.default)('Hot Spot'),
    matching: (0, _formatMessage.default)('Matching'),
    'multi-answer': (0, _formatMessage.default)('Multiple Answer'),
    numeric: (0, _formatMessage.default)('Numeric'),
    ordering: (0, _formatMessage.default)('Ordering'),
    'true-false': (0, _formatMessage.default)('True or False')
  }[intType.slug] || intType.name;
};

var interactionTypeMetadata = function interactionTypeMetadata(intType) {
  return {
    icon: interactionTypesIconDictionary(intType),
    name: interactionTypesNameDictionary(intType)
  };
};

exports.interactionTypeMetadata = interactionTypeMetadata;