"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onTablet = exports.onPhone = exports.media = void 0;
var media = {
  'phone-break-point': 'only screen and (max-width: 48rem)',
  'tablet-break-point': 'only screen and (max-width: 64rem)'
};
exports.media = media;

var onPhone = function onPhone() {
  var windowObj = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : window;
  var mediaQueryString = media['phone-break-point'];
  return windowObj.matchMedia(mediaQueryString).matches;
};

exports.onPhone = onPhone;

var onTablet = function onTablet() {
  var windowObj = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : window;
  var mediaQueryString = media['tablet-break-point'];
  return !onPhone(windowObj) && windowObj.matchMedia(mediaQueryString).matches;
};

exports.onTablet = onTablet;