"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _Button = _interopRequireDefault(require("@instructure/ui-buttons/lib/components/Button"));

var _CloseButton = _interopRequireDefault(require("@instructure/ui-buttons/lib/components/CloseButton"));

var _Heading = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Heading"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _constants = require("@instructure/quiz-common/lib/constants");

var _Modal = _interopRequireWildcard(require("@instructure/quiz-common/lib/components/Modal"));

var MoveImmutableModal =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(MoveImmutableModal, _Component);

  function MoveImmutableModal() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, MoveImmutableModal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(MoveImmutableModal)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleSubmit = function (e) {
      var _this$props = _this.props,
          quizId = _this$props.quizId,
          position = _this$props.position,
          stimulusQuizEntryId = _this$props.stimulusQuizEntryId,
          quizEntry = _this$props.quizEntry;

      _this.props.closeModal();

      _this.props.setUI(_constants.MOVED_IN_SIDEBAR, _this.props.movedInSidebar);

      _this.props.moveImmutableQuizEntry(quizId, position, stimulusQuizEntryId, quizEntry.id);
    };

    _this.closeAction = function () {
      _this.props.closeModal();
    };

    return _this;
  }

  (0, _createClass2.default)(MoveImmutableModal, [{
    key: "cancelButton",
    value: function cancelButton() {
      return _react.default.createElement(_Button.default, {
        onClick: this.closeAction,
        margin: _constants.XSMALL_SIDE_MARGIN
      }, "\u0625\u0644\u063A\u0627\u0621");
    }
  }, {
    key: "doneButton",
    value: function doneButton() {
      return _react.default.createElement(_Button.default, {
        variant: "primary",
        onClick: this.handleSubmit,
        margin: _constants.XSMALL_SIDE_MARGIN
      }, "\u0627\u0644\u0627\u0633\u062A\u0646\u0633\u0627\u062E \u0648\u0627\u0644\u0646\u0642\u0644");
    }
  }, {
    key: "renderBody",
    value: function renderBody() {
      return _react.default.createElement("div", null, "\u0633\u064A\u0624\u062F\u064A \u0627\u0644\u0646\u0642\u0644 \u0625\u0644\u0649 \u0647\u0630\u0627 \u0627\u0644\u0645\u0643\u0627\u0646 \u0625\u0644\u0649 \u0627\u0633\u062A\u0646\u0633\u0627\u062E \u0627\u0644\u0633\u0624\u0627\u0644 \u0648\u062A\u063A\u064A\u064A\u0631 \u0645\u062D\u0641\u0632\u0647 \u0627\u0644\u0645\u0635\u0627\u062D\u0628 \u0645\u0639 \u0628\u062F\u0621 \u0627\u0644\u0637\u0644\u0627\u0628 \u0628\u0627\u0644\u0641\u0639\u0644 \u0628\u0627\u0644\u0625\u062C\u0627\u0628\u0629 \u0639\u0644\u064A\u0647.");
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_Modal.default, {
        open: this.props.modalOpen,
        onDismiss: this.closeAction,
        size: "small",
        label: "\u062A\u0623\u0643\u064A\u062F \u0627\u0644\u0627\u0633\u062A\u0646\u0633\u0627\u062E \u0648\u0627\u0644\u0646\u0642\u0644"
      }, _react.default.createElement(_Modal.ModalHeader, null, _react.default.createElement(_Heading.default, {
        level: "reset",
        as: "h2"
      }, "\u062A\u0623\u0643\u064A\u062F \u0627\u0644\u0627\u0633\u062A\u0646\u0633\u0627\u062E \u0648\u0627\u0644\u0646\u0642\u0644"), _react.default.createElement(_CloseButton.default, {
        onClick: this.closeAction,
        placement: "end",
        offset: "medium",
        variant: "icon"
      }, "\u0625\u063A\u0644\u0627\u0642")), _react.default.createElement(_Modal.ModalBody, null, _react.default.createElement(_Text.default, null, this.renderBody())), _react.default.createElement(_Modal.ModalFooter, null, this.cancelButton(), this.doneButton()));
    }
  }]);
  MoveImmutableModal.displayName = "MoveImmutableModal";
  return MoveImmutableModal;
}(_react.Component);

exports.default = MoveImmutableModal;
MoveImmutableModal.propTypes = {
  closeModal: _propTypes.default.func.isRequired,
  modalOpen: _propTypes.default.bool.isRequired,
  moveImmutableQuizEntry: _propTypes.default.func.isRequired,
  movedInSidebar: _propTypes.default.bool,
  position: _propTypes.default.number,
  quizEntry: _reactImmutableProptypes.default.record,
  quizId: _propTypes.default.string,
  setUI: _propTypes.default.func.isRequired,
  stimulusQuizEntryId: _propTypes.default.string
};
MoveImmutableModal.defaultProps = {
  movedInSidebar: false,
  position: void 0,
  quizEntry: void 0,
  quizId: void 0,
  stimulusQuizEntryId: void 0
};