"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _get2 = _interopRequireDefault(require("@babel/runtime/helpers/get"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime/helpers/applyDecoratedDescriptor"));

var _immutable = _interopRequireWildcard(require("immutable"));

var _interactionPoints = _interopRequireDefault(require("quiz-interactions/lib/util/interactionPoints"));

var _instUIMessages = require("../../common/util/instUIMessages");

var _reduxRecord = _interopRequireDefault(require("./reduxRecord"));

var _Item2 = _interopRequireDefault(require("./Item"));

var _Bank2 = _interopRequireDefault(require("./Bank"));

var _Stimulus2 = _interopRequireDefault(require("./Stimulus"));

var _BankEntry2 = _interopRequireDefault(require("./BankEntry"));

var _constants = require("@instructure/quiz-common/lib/constants");

var _immutableHelpers = require("../util/immutableHelpers");

var _withStateCache = _interopRequireDefault(require("../util/withStateCache"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _dec,
    _class,
    _temp,
    _default_ar_number = Intl.NumberFormat("ar", { style: "decimal" }).format;

var acceptedVerbs = [_constants.REMOVE, _constants.MOVE, _constants.EDIT];
var ENTRY_TYPE_STIMULUS = 'Stimulus';
var QuizEntry = (_dec = (0, _withStateCache.default)(function () {
  return [['quizEntries'], ['modifications', 'quizEntries']];
}), (_class = (_temp =
/*#__PURE__*/
function (_ReduxRecord) {
  (0, _inherits2.default)(QuizEntry, _ReduxRecord);

  function QuizEntry() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, QuizEntry);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(QuizEntry)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.__getStimulusEntries = function () {
      var childEntries = _this.getState().get('quizEntries', (0, _immutable.Map)()).filter(function (entry) {
        return entry.get('stimulusQuizEntryId') === _this.id;
      });

      var temporaryItem = _this.getState().getIn(['modifications', 'quizEntries', _constants.TEMPORARY_QUIZ_ENTRY_ID]);

      if (temporaryItem && temporaryItem.get('stimulusQuizEntryId') === _this.id) {
        childEntries = childEntries.set(temporaryItem.id, QuizEntry.create(temporaryItem));
      }

      var quizEntries = childEntries.map(function (entry) {
        return QuizEntry.create(entry);
      }).sortBy(function (qe) {
        return qe.position;
      }).toList();
      return quizEntries || (0, _immutable.List)();
    };

    _this.__getBankEntryEntries = function () {
      if (_this.hasStimulus) {
        return _this.__getStimulusEntries();
      } else {
        return (0, _immutable.List)([(0, _assertThisInitialized2.default)(_this)]);
      }
    };

    return _this;
  }

  (0, _createClass2.default)(QuizEntry, [{
    key: "getErrors",
    value: function getErrors() {
      return (0, _get2.default)((0, _getPrototypeOf3.default)(QuizEntry.prototype), "getErrors", this).call(this, this).merge({
        sampleNum: this.sampleNumErrors(),
        deletedBank: this.deletedBankErrors(),
        pointsPossible: this.pointsPossibleErrors()
      });
    }
  }, {
    key: "isNumber",
    value: function isNumber(numString) {
      return Number(numString).toString() === numString;
    }
  }, {
    key: "sampleNumErrors",
    value: function sampleNumErrors() {
      var errors = [];
      var selection = this.selection;

      if (!this.isBank || selection === 'all' || this.isArchivedBank) {
        return (0, _instUIMessages.toErrors)(errors);
      }

      var sample = this.properties.get('sampleNum', '');
      var parsedNumber = parseInt(sample, 10);

      if (parsedNumber < 1) {
        errors.push("\u064A\u062C\u0628 \u0623\u0646 \u064A\u0643\u0648\u0646 1 \u0639\u0644\u0649 \u0627\u0644\u0623\u0642\u0644");
      }

      if (parsedNumber > this.getEntry().itemEntryCount) {
        var _s, _n;

        errors.push((_s = this.getEntry().itemEntryCount, _n = +_s, (_n === 1 ? "\u062A\u0645 \u062A\u062C\u0627\u0648\u0632 \u0627\u0644\u062D\u062F \u0627\u0644\u0623\u0642\u0635\u0649 \u0644\u0644\u0639\u062F\u062F (\u064A\u062D\u062A\u0648\u064A \u0647\u0630\u0627 \u0627\u0644\u0628\u0646\u0643 \u0639\u0644\u0649 1 \u0633\u0624\u0627\u0644)" : "\u062A\u0645 \u062A\u062C\u0627\u0648\u0632 \u0627\u0644\u062D\u062F \u0627\u0644\u0623\u0642\u0635\u0649 \u0644\u0644\u0639\u062F\u062F (\u064A\u062D\u062A\u0648\u064A \u0647\u0630\u0627 \u0627\u0644\u0628\u0646\u0643 \u0639\u0644\u0649 " + _default_ar_number(this.getEntry().itemEntryCount) + " \u0623\u0633\u0626\u0644\u0629)")));
      }

      if (!Number.isInteger(Number(sample)) || isNaN(parsedNumber) || !this.isNumber(sample)) {
        errors.push("\u064A\u062C\u0628 \u0623\u0646 \u064A\u0643\u0648\u0646 \u0639\u062F\u062F\u064B\u0627 \u0635\u062D\u064A\u062D\u064B\u0627");
      }

      return (0, _instUIMessages.toErrors)(errors);
    }
  }, {
    key: "deletedBankErrors",
    value: function deletedBankErrors() {
      var errors = [];

      if (this.isArchivedBank) {
        errors.push("\u0628\u0646\u0643 \u0627\u0644\u0639\u0646\u0627\u0635\u0631 \u0647\u0630\u0627 \u0644\u0645 \u064A\u0639\u062F \u0645\u0648\u062C\u0648\u062F\u064B\u0627. \u064A\u0631\u062C\u0649 \u062A\u062D\u062F\u064A\u062F \u0628\u0646\u0643 \u0635\u0627\u0644\u062D.");
      }

      return (0, _instUIMessages.toErrors)(errors);
    }
  }, {
    key: "pointsPossibleErrors",
    value: function pointsPossibleErrors() {
      var errors = [];
      var possible = this.pointsPossible;

      if (!this.isNumber(possible.toString())) {
        errors.push("\u064A\u062C\u0628 \u0623\u0646 \u064A\u0643\u0648\u0646 \u0639\u062F\u062F\u064B\u0627");
      }

      return (0, _instUIMessages.toErrors)(errors);
    }
  }, {
    key: "getEntry",
    value: function getEntry() {
      var _this2 = this;

      var entry;

      if (this.entry === _constants.TEMPORARY_ITEM_ID) {
        entry = _Item2.default.create(this.getState().getIn(['modifications', 'items', _constants.TEMPORARY_ITEM_ID]));
      } else if (this.entry === _constants.TEMPORARY_STIMULUS_ID) {
        entry = _Stimulus2.default.create(this.getState().getIn(['modifications', 'stimuli', _constants.TEMPORARY_STIMULUS_ID]));
      }

      if (entry === void 0) {
        var entryId = this.entryId || this.entry.get('id');
        var entryCreator = {
          Bank: function Bank() {
            return _Bank2.default.create(_this2.getState().getIn(['banks', entryId]));
          },
          BankEntry: function BankEntry() {
            return _BankEntry2.default.create(_this2.getState().getIn(['bankEntries', entryId]));
          },
          Item: function Item() {
            return _Item2.default.create(_this2.getState().getIn(['items', entryId]));
          },
          Stimulus: function Stimulus() {
            return _Stimulus2.default.create(_this2.getState().getIn(['stimuli', entryId]));
          }
        };
        if (!entryCreator[this.entryType]) return;
        entry = entryCreator[this.entryType]();
      }

      entry.quizEntry = this;
      return entry;
    }
  }, {
    key: "getItem",
    value: function getItem() {
      var entry = this.getEntry();
      var itemCreator = {
        BankEntry: function BankEntry() {
          return entry.getEntry();
        },
        Item: function Item() {
          return entry;
        }
      }[this.entryType];
      if (!itemCreator) return; // Assume we want working item if accessed on working quiz entry.

      var item = itemCreator();
      if (!item) return;
      var currentItem = this.isWorkingInstance ? item.getWorkingInstance() : item;
      var overrides = this.getWorkingInstance().properties.get('itemOverrides');
      return currentItem.mergeWith(_immutableHelpers.mergeDeepOnlyMaps, overrides);
    }
  }, {
    key: "getNestedEntries",
    // This will currently trigger rerendering of all stimuli if any QuizEntry changes.
    // Possibly the `withStateCache` decorator could be made more sophisticated to deal
    // with this flaw.
    value: function getNestedEntries() {
      var _this3 = this;

      var getNestedEntriesFunction = {
        Bank: function Bank() {
          return (0, _immutable.List)([_this3]);
        },
        BankEntry: this.__getBankEntryEntries,
        Item: function Item() {
          return (0, _immutable.List)([_this3]);
        },
        Stimulus: this.__getStimulusEntries
      }[this.entryType];
      return getNestedEntriesFunction ? getNestedEntriesFunction() : (0, _immutable.List)();
    }
  }, {
    key: "getProperties",
    value: function getProperties() {
      return {
        points_possible: this.pointsPossible && parseFloat(this.pointsPossible),
        position: this.position && Math.ceil(this.position),
        stimulus_quiz_entry_id: this.stimulusQuizEntryId
      };
    }
  }, {
    key: "isImmutable",
    value: function isImmutable() {
      return this.status === 'immutable';
    }
  }, {
    key: "hasModifications",
    value: function hasModifications() {
      return !_immutable.default.is(this.getWorkingInstance().delete('isWorkingInstance'), this.delete('isWorkingInstance'));
    }
  }, {
    key: "getWorkingInstance",
    value: function getWorkingInstance() {
      var data = this.mergeWith(_immutableHelpers.mergeDeepOnlyMaps, this.getState().getIn(['modifications', 'quizEntries', this.id])).set('isWorkingInstance', true);
      return QuizEntry.create(data);
    }
  }, {
    key: "generateScreenReaderText",

    /* eslint-disable format-message/no-missing-params */
    value: function generateScreenReaderText(displayPosition, verb) {
      if (!acceptedVerbs.includes(verb)) {
        // eslint-disable-next-line no-console
        console.error("".concat(verb, " not an accepted verb. Must be one of ").concat(acceptedVerbs));
      } // Due to possible translation nuances, the remove, edit, and move verbs are broken out into
      // their own possible string so that translators can better translate the meaning


      var type;

      if (this.isStimulus || this.isBank) {
        type = this.isStimulus ? "\u0627\u0644\u0645\u062D\u0641\u0632" : "\u0627\u0644\u0628\u0646\u0643";

        if (this.positionSlots > 1) {
          var opts = {
            type: type,
            start: displayPosition,
            end: displayPosition + this.positionSlots
          };
          return {
            Remove: "\u0642\u0645 \u0628\u0625\u0632\u0627\u0644\u0629 " + opts.type + " \u0639\u0646\u0627\u0635\u0631 \u0645\u062A\u0636\u0645\u0646\u0629 \u0645\u0646 " + _default_ar_number(opts.start) + " \u062D\u062A\u0649 " + _default_ar_number(opts.end) + ".",
            Edit: "\u0642\u0645 \u0628\u062A\u062D\u0631\u064A\u0631 " + opts.type + " \u0639\u0646\u0627\u0635\u0631 \u0645\u062A\u0636\u0645\u0646\u0629 \u0645\u0646 " + _default_ar_number(opts.start) + " \u062D\u062A\u0649 " + _default_ar_number(opts.end) + ".",
            Move: "\u062D\u0631\u0643 " + opts.type + " \u0639\u0646\u0627\u0635\u0631 \u0645\u062A\u0636\u0645\u0646\u0629 \u0645\u0646 " + _default_ar_number(opts.start) + " \u062D\u062A\u0649 " + _default_ar_number(opts.end) + "."
          }[verb];
        } else if (this.positionSlots === 1) {
          var _opts = {
            type: type,
            start: displayPosition
          };
          return {
            Remove: "\u0642\u0645 \u0628\u0625\u0632\u0627\u0644\u0629 " + _opts.type + " \u0645\u062A\u0636\u0645\u0646 \u0644\u0639\u0646\u0635\u0631 \u0645\u062A\u0636\u0645\u0646 \u0645\u0646 " + _default_ar_number(_opts.start) + ".",
            Edit: "\u0642\u0645 \u0628\u062A\u062D\u0631\u064A\u0631 " + _opts.type + " \u0639\u0646\u0635\u0631 \u0645\u062A\u0636\u0645\u0646 \u0645\u0646 " + _default_ar_number(_opts.start) + ".",
            Move: "\u062D\u0631\u0643 " + _opts.type + " \u0639\u0646\u0635\u0631 \u0645\u062A\u0636\u0645\u0646 \u0645\u0646 " + _default_ar_number(_opts.start) + "."
          }[verb];
        } else {
          var _opts2 = {
            type: type,
            start: displayPosition,
            end: displayPosition + this.positionSlots
          };
          return {
            Remove: "\u0642\u0645 \u0628\u0625\u0632\u0627\u0644\u0629 " + _opts2.type + " \u0641\u0627\u0631\u063A \u0628\u064A\u0646 \u0627\u0644\u0648\u0636\u0639\u064A\u0646 " + _default_ar_number(_opts2.start) + " \u0648" + _default_ar_number(_opts2.end) + ".",
            Edit: "\u0642\u0645 \u0628\u062A\u062D\u0631\u064A\u0631 " + _opts2.type + " \u0641\u0627\u0631\u063A \u0628\u064A\u0646 \u0627\u0644\u0648\u0636\u0639\u064A\u0646 " + _default_ar_number(_opts2.start) + " \u0648" + _default_ar_number(_opts2.end) + ".",
            Move: "\u062D\u0631\u0643 " + _opts2.type + " \u0641\u0627\u0631\u063A \u0628\u064A\u0646 \u0627\u0644\u0648\u0636\u0639\u064A\u0646 " + _default_ar_number(_opts2.start) + " \u0648" + _default_ar_number(_opts2.end) + "."
          }[verb];
        }
      } else {
        type = this.isBankEntry ? "\u0625\u062F\u062E\u0627\u0644 \u0628\u0646\u0643" : "\u0627\u0644\u0639\u0646\u0635\u0631";
        var _opts3 = {
          verb: verb,
          type: type,
          position: displayPosition
        };
        return {
          Remove: "\u0642\u0645 \u0628\u0625\u0632\u0627\u0644\u0629 " + _opts3.type + " \u0641\u064A \u0627\u0644\u0645\u0648\u0636\u0639 " + _default_ar_number(_opts3.position) + ".",
          Edit: "\u0642\u0645 \u0628\u062A\u062D\u0631\u064A\u0631 " + _opts3.type + " \u0641\u064A \u0627\u0644\u0645\u0648\u0636\u0639 " + _default_ar_number(_opts3.position) + ".",
          Move: "\u062D\u0631\u0643 " + _opts3.type + " \u0641\u064A \u0627\u0644\u0648\u0636\u0639 " + _default_ar_number(_opts3.position) + "."
        }[verb];
      }
    }
    /* eslint-enable format-message/no-missing-params */

  }, {
    key: "positionToDisplay",
    value: function positionToDisplay(displayPosition) {
      if (this.isBank && this.sizeOfBank > 1 && this.sampleNum !== 1) {
        return _default_ar_number(displayPosition) + " - " + _default_ar_number(displayPosition + (this.sizeOfBank - 1));
      }

      return _default_ar_number(displayPosition);
    }
  }, {
    key: "state",
    value: function state() {
      return this.getState();
    }
  }, {
    key: "isArchivedBankEntry",
    get: function get() {
      return this.isBankEntry && this.getEntry().archived;
    }
  }, {
    key: "isArchivedBank",
    get: function get() {
      return this.isBank && this.getEntry().archived;
    }
  }, {
    key: "hasStimulus",
    get: function get() {
      return this.isStimulus || this.isBankEntry && this.getEntry().getEntry().isStimulus;
    }
  }, {
    key: "hasNestedRecords",
    get: function get() {
      return this.hasStimulus;
    }
  }, {
    key: "isBank",
    get: function get() {
      return this.entryType === 'Bank';
    }
  }, {
    key: "isBankEntry",
    get: function get() {
      return this.entryType === 'BankEntry';
    }
  }, {
    key: "isStimulus",
    get: function get() {
      return this.entryType === 'Stimulus';
    }
  }, {
    key: "isItem",
    get: function get() {
      return this.entryType === 'Item';
    }
  }, {
    key: "isInStimulus",
    get: function get() {
      return !isNaN(parseInt(this.stimulusQuizEntryId, 10));
    }
  }, {
    key: "isTemporary",
    get: function get() {
      return this.id === _constants.TEMPORARY_QUIZ_ENTRY_ID;
    }
  }, {
    key: "type",
    get: function get() {
      return this.entryType;
    }
  }, {
    key: "pointsPossible",
    get: function get() {
      if (this.get('entryType') === ENTRY_TYPE_STIMULUS) {
        return 0;
      }

      var item = this.getItem();
      var itemPoints = item && (0, _interactionPoints.default)(item.toJS());
      return itemPoints === void 0 ? this.get('pointsPossible') : itemPoints;
    }
  }, {
    key: "sampleNum",
    get: function get() {
      return parseInt(this.properties.get('sampleNum'), 10);
    }
  }, {
    key: "selection",
    get: function get() {
      return this.properties.get('selection') || (this.sampleNum > 0 ? 'rand' : 'all');
    }
  }, {
    key: "sizeOfBank",
    get: function get() {
      if (!this.isBank) return 0;
      return this.sampleNum > 0 ? this.sampleNum : this.getEntry().itemEntryCount;
    }
  }, {
    key: "positionSlots",
    get: function get() {
      if (this.hasNestedRecords) {
        return this.getNestedEntries().size;
      }

      return 1;
    }
  }, {
    key: "displayPositionSlots",
    get: function get() {
      if (this.isBank) {
        return this.sampleNum || this.getEntry().itemEntryCount;
      }

      if (this.hasStimulus) {
        return this.getNestedEntries().reduce(function (sum, quizEntry) {
          return sum + quizEntry.displayPositionSlots;
        }, 0);
      }

      return 1;
    }
  }]);
  return QuizEntry;
}((0, _reduxRecord.default)({
  id: '0',
  entryEditable: true,
  entry: (0, _immutable.Map)(),
  entryId: null,
  entryType: null,
  isWorkingInstance: false,
  pointsPossible: 1,
  position: null,
  properties: (0, _immutable.Map)(),
  regradeAdjustedPointsPossible: null,
  regradeAdjustedScoringData: null,
  status: 'mutable',
  stimulusQuizEntryId: null
})), _temp), ((0, _applyDecoratedDescriptor2.default)(_class.prototype, "getNestedEntries", [_dec], Object.getOwnPropertyDescriptor(_class.prototype, "getNestedEntries"), _class.prototype)), _class));
exports.default = QuizEntry;