"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.interactionTypeMetadata = void 0;

var _IconPlus = _interopRequireDefault(require("@instructure/ui-icons/lib/Line/IconPlus"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

// TODO: Add correct icon file imports when they are in inst icons
// import MultipleChoiceIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MultipleAnswerIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import TrueOrFalseIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MatchingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import OrderingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import FillBlankIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import EssayIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
var interactionTypesIconDictionary = function interactionTypesIconDictionary(intType) {
  return {// TODO: Uncomment when we have the icons imported
    // 'choice': MultipleChoiceIcon,
    // 'multi-answer': MultipleAnswerIcon,
    // 'true-false': TrueOrFalseIcon,
    // 'matching': MatchingIcon,
    // 'ordering': OrderingIcon,
    // 'fill-blank': FillBlankIcon,
    // 'essay': EssayIcon
  }[intType.slug] || _IconPlus.default;
};

var interactionTypesNameDictionary = function interactionTypesNameDictionary(intType) {
  return {
    categorization: "\u0627\u0644\u062A\u0635\u0646\u064A\u0641",
    choice: "\u0627\u062E\u062A\u064A\u0627\u0631 \u0645\u0646 \u0645\u062A\u0639\u062F\u062F",
    essay: "\u0645\u0642\u0627\u0644",
    'file-upload': "\u062A\u062D\u0645\u064A\u0644 \u0645\u0644\u0641",
    'fill-blank': "\u062A\u0639\u0628\u0626\u0629 \u0627\u0644\u0641\u0631\u0627\u063A",
    formula: "\u0627\u0644\u0635\u064A\u063A\u0629",
    'hot-spot': "\u0646\u0642\u0637\u0629 \u0633\u0627\u062E\u0646\u0629",
    matching: "\u0627\u0644\u0645\u0637\u0627\u0628\u0642\u0629",
    'multi-answer': "\u0625\u062C\u0627\u0628\u0629 \u0645\u062A\u0639\u062F\u062F\u0629",
    numeric: "\u0631\u0642\u0645\u064A",
    ordering: "\u0627\u0644\u062A\u0631\u062A\u064A\u0628",
    'true-false': "\u0635\u0648\u0627\u0628 \u0623\u0645 \u062E\u0637\u0623"
  }[intType.slug] || intType.name;
};

var interactionTypeMetadata = function interactionTypeMetadata(intType) {
  return {
    icon: interactionTypesIconDictionary(intType),
    name: interactionTypesNameDictionary(intType)
  };
};

exports.interactionTypeMetadata = interactionTypeMetadata;