"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.interactionTypeMetadata = void 0;

var _IconPlus = _interopRequireDefault(require("@instructure/ui-icons/lib/Line/IconPlus"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

// TODO: Add correct icon file imports when they are in inst icons
// import MultipleChoiceIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MultipleAnswerIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import TrueOrFalseIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MatchingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import OrderingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import FillBlankIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import EssayIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
var interactionTypesIconDictionary = function interactionTypesIconDictionary(intType) {
  return {// TODO: Uncomment when we have the icons imported
    // 'choice': MultipleChoiceIcon,
    // 'multi-answer': MultipleAnswerIcon,
    // 'true-false': TrueOrFalseIcon,
    // 'matching': MatchingIcon,
    // 'ordering': OrderingIcon,
    // 'fill-blank': FillBlankIcon,
    // 'essay': EssayIcon
  }[intType.slug] || _IconPlus.default;
};

var interactionTypesNameDictionary = function interactionTypesNameDictionary(intType) {
  return {
    categorization: "Kategorisering",
    choice: "Flere valg",
    essay: "Opgave",
    'file-upload': "Filoverf\xF8rsel",
    'fill-blank': "Udfyld det blanke",
    formula: "Formel",
    'hot-spot': "Hot-spot",
    matching: "Matchende",
    'multi-answer': "Flere svar",
    numeric: "Numerisk",
    ordering: "R\xE6kkef\xF8lge",
    'true-false': "Sandt eller falsk"
  }[intType.slug] || intType.name;
};

var interactionTypeMetadata = function interactionTypeMetadata(intType) {
  return {
    icon: interactionTypesIconDictionary(intType),
    name: interactionTypesNameDictionary(intType)
  };
};

exports.interactionTypeMetadata = interactionTypeMetadata;