"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.propsForBankEntryUnauthorizedEdit = exports.propsForStimulusBankEntryEditPrompt = exports.propsForItemBankEntryEditPrompt = exports.propsForBankEntryEditPrompt = exports.propsForBankEntryVersioningWrapper = exports.propsForStimulusVersioningWrapper = exports.propsForItemVersioningWrapper = void 0;

var _react = _interopRequireDefault(require("react"));

var _partial = _interopRequireDefault(require("lodash/partial"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var immutableItemDescription = _react.default.createElement(_Text.default, null, _react.default.createElement("b", null, "Certains \xE9l\xE8ves ont d\xE9j\xE0 soumis des r\xE9ponses \xE0 cet \xE9l\xE9ment\xA0!"), "\xA0", "Vous pouvez appliquer vos modifications \xE0 une copie de l\u2019\xE9l\xE9ment, lequel ne sera visible que par les \xE9l\xE8ves n\u2019ayant pas encore fait cette \xE9valuation.");

var itemCopyDescription = _react.default.createElement(_Text.default, null, _react.default.createElement("b", null, "Modification d\u2019une copie..."), "\xA0", "Les statistiques d\u2019\xE9l\xE9ments issues de cette nouvelle copie appara\xEEtront s\xE9par\xE9ment de celles de la version pr\xE9c\xE9dente de cette question.");

var immutableStimulusDescription = _react.default.createElement(_Text.default, null, _react.default.createElement("b", null, "Certains \xE9l\xE8ves ont d\xE9j\xE0 soumis des r\xE9ponses \xE0 ce stimulus\xA0!"), "\xA0", "Vous pouvez appliquer vos modifications \xE0 une copie du stimulus, lequel ne sera visible que par les \xE9l\xE8ves n\u2019ayant pas encore fait cette \xE9valuation. Les \xE9l\xE9ments joints seront \xE9galement copi\xE9s.");

var stimulusCopyDescription = _react.default.createElement(_Text.default, null, _react.default.createElement("b", null, "Modification d\u2019une copie..."), "\xA0", "Les statistiques de stimulus issues de cette nouvelle copie appara\xEEtront s\xE9par\xE9ment de celles de la version pr\xE9c\xE9dente.");

var itemBankEntryEditDescription = _react.default.createElement(_Text.default, null, _react.default.createElement("b", null, "\xC9l\xE9ment en banque."), "\xA0", "Certaines options et la valeur des points peuvent \xEAtre param\xE9tr\xE9es d\u2019ici, mais l\u2019\xE9dition doit se faire depuis la banque.");

var stimulusBankEntryEditDescription = _react.default.createElement(_Text.default, {
  "data-automation": "sdk-editInBanks-warning"
}, _react.default.createElement("b", null, "Stimulus dans une banque"), "\xA0", "La modification de ce stimulus doit se faire au sein de la banque");

var bankEntryUnauthorizedEditDescription = _react.default.createElement(_Text.default, null, _react.default.createElement("b", null, "\xC9l\xE9ment en banque."), "\xA0", "Vous n\u2019\xEAtes pas autoris\xE9 \xE0 modifier cet \xE9l\xE9ment.");

var archivedBankEntryDescription = _react.default.createElement(_Text.default, null, "Cet \xE9l\xE9ment a \xE9t\xE9 supprim\xE9 de la banque d\u2019\xE9l\xE9ment. Les \xE9l\xE8ves le verront encore sur les tentatives futures. Pour modifier, faites une copie de l\u2019\xE9l\xE9ment.");

var propsForVersioningWrapper = function propsForVersioningWrapper(copyDescription, immutableDescription, isImmutable, shouldClone, setShouldClone, switchOffEditing, isEditing) {
  var alertType = arguments.length > 7 && arguments[7] !== void 0 ? arguments[7] : 'warning';
  var defaultProps = {
    disableChildren: false,
    showAlert: false
  };
  if (!isEditing) return {
    showAlert: false
  };

  if (isImmutable && shouldClone) {
    Object.assign(defaultProps, {
      description: copyDescription,
      hideActions: true,
      showAlert: true
    });
  } else if (isImmutable) {
    Object.assign(defaultProps, {
      alertType: alertType,
      cancelActionCallback: switchOffEditing,
      defaultActionCallback: (0, _partial.default)(setShouldClone, true),
      defaultActionText: "Modifier une copie",
      description: immutableDescription,
      disableChildren: true,
      showAlert: true
    });
  }

  return defaultProps;
};

var propsForItemVersioningWrapper = function propsForItemVersioningWrapper() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return propsForVersioningWrapper.apply(void 0, [itemCopyDescription, immutableItemDescription].concat(args));
};

exports.propsForItemVersioningWrapper = propsForItemVersioningWrapper;

var propsForStimulusVersioningWrapper = function propsForStimulusVersioningWrapper() {
  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  return propsForVersioningWrapper.apply(void 0, [stimulusCopyDescription, immutableStimulusDescription].concat(args));
};

exports.propsForStimulusVersioningWrapper = propsForStimulusVersioningWrapper;

var propsForBankEntryVersioningWrapper = function propsForBankEntryVersioningWrapper() {
  for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    args[_key3] = arguments[_key3];
  }

  return propsForVersioningWrapper.apply(void 0, [itemCopyDescription, archivedBankEntryDescription].concat(args));
};

exports.propsForBankEntryVersioningWrapper = propsForBankEntryVersioningWrapper;

var propsForBankEntryEditPrompt = function propsForBankEntryEditPrompt(isEditing, switchOffEditing, defaultActionCallback, description) {
  if (!isEditing) return {
    showAlert: false
  };
  return {
    cancelActionCallback: switchOffEditing,
    disableChildren: true,
    description: description,
    defaultActionCallback: defaultActionCallback,
    defaultActionText: "Modifier dans la banque",
    showAlert: true
  };
};

exports.propsForBankEntryEditPrompt = propsForBankEntryEditPrompt;

var propsForItemBankEntryEditPrompt = function propsForItemBankEntryEditPrompt() {
  for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
    args[_key4] = arguments[_key4];
  }

  return propsForBankEntryEditPrompt.apply(void 0, args.concat([itemBankEntryEditDescription]));
};

exports.propsForItemBankEntryEditPrompt = propsForItemBankEntryEditPrompt;

var propsForStimulusBankEntryEditPrompt = function propsForStimulusBankEntryEditPrompt() {
  for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
    args[_key5] = arguments[_key5];
  }

  return propsForBankEntryEditPrompt.apply(void 0, args.concat([stimulusBankEntryEditDescription]));
};

exports.propsForStimulusBankEntryEditPrompt = propsForStimulusBankEntryEditPrompt;

var propsForBankEntryUnauthorizedEdit = function propsForBankEntryUnauthorizedEdit(isEditing) {
  if (!isEditing) return {
    showAlert: false
  };
  return {
    alertType: 'warning',
    disableChildren: true,
    description: bankEntryUnauthorizedEditDescription,
    hideActions: true,
    showAlert: true
  };
};

exports.propsForBankEntryUnauthorizedEdit = propsForBankEntryUnauthorizedEdit;