"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _debounce = _interopRequireDefault(require("lodash/fp/debounce"));

var _find = _interopRequireDefault(require("lodash/fp/find"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _Select = _interopRequireDefault(require("@instructure/ui-forms/lib/components/Select"));

var _AccessibleContent = _interopRequireDefault(require("@instructure/ui-a11y/lib/components/AccessibleContent"));

var AsyncSearch =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(AsyncSearch, _Component);

  function AsyncSearch() {
    var _this;

    (0, _classCallCheck2.default)(this, AsyncSearch);
    _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(AsyncSearch).apply(this, arguments));
    _this.state = {
      loading: false,
      searchResult: [],
      searchInput: ''
    };

    _this.cleanResults = function () {
      _this.setEmptyOption();

      _this.setState({
        searchResult: []
      });
    };

    _this.handleClose = function () {
      if (!_this.state.searchInput) {
        _this.cleanResults();
      }
    };

    _this.handleSearchInputChange = function (event, value) {
      var longEnough = value && value.length >= _this.props.minChars;

      _this.setState({
        searchInput: value,
        loading: !!value && longEnough
      });

      if (!value) {
        _this.cleanResults();
      } else if (longEnough) {
        _this.search(value);
      }
    };

    _this.handleSearchSelectionChange = function (event, newValues) {
      _this.props.onSelectionChange(newValues.map(function (_ref) {
        var id = _ref.id;
        return (0, _find.default)({
          uuid: id
        }, _this.state.searchResult) || (0, _find.default)({
          uuid: id
        }, _this.props.selectedOption);
      }));
    };

    _this.formatSelectedOption = function (option) {
      return _react.default.createElement(_AccessibleContent.default, {
        alt: option.label + "\u3092\u524A\u9664\u3059\u308B"
      }, option.label);
    };

    _this.search = (0, _debounce.default)(_this.props.debounceDelay, function (value) {
      // TODO add the promise cancellation for avoiding having disordered requests
      _this.props.search(value).then(function (searchResult) {
        _this.setState({
          searchResult: searchResult,
          emptyOption: "\u7D50\u679C\u306A\u3057",
          loading: false
        });
      });
    });
    return _this;
  }

  (0, _createClass2.default)(AsyncSearch, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setEmptyOption();
    }
  }, {
    key: "setEmptyOption",
    value: function setEmptyOption() {
      var minCharsMessage = "\u691C\u7D22\u8A9E\u306F\u5C11\u306A\u304F\u3068\u3082 " + this.props.minChars + "\u6587\u5B57\u3067\u306A\u3051\u308C\u3070\u306A\u308A\u307E\u305B\u3093";
      this.setState({
        emptyOption: this.props.minChars > 1 ? minCharsMessage : "\u66F8\u304D\u8FBC\u3093\u3067\u691C\u7D22"
      });
    }
  }, {
    key: "render",
    value: function render() {
      var selectedOption = this.props.selectedOption.map(function (_ref2) {
        var uuid = _ref2.uuid,
            fullName = _ref2.fullName;
        return {
          id: uuid,
          value: uuid,
          label: fullName
        };
      });
      return _react.default.createElement(_Select.default, {
        "data-automation": "sdk-item-bank-share-input",
        editable: true,
        emptyOption: this.state.emptyOption,
        filter: this.props.selectionFilter,
        label: "\uFF08\uFF09\u3068\u5171\u6709",
        loadingText: this.state.loading ? "\u30AA\u30D7\u30B7\u30E7\u30F3\u3092\u8AAD\u307F\u8FBC\u3080" : null,
        formatSelectedOption: this.formatSelectedOption,
        multiple: true,
        onChange: this.handleSearchSelectionChange,
        onClose: this.handleClose,
        onInputChange: this.handleSearchInputChange,
        placeholder: "\u540D\u524D\u307E\u305F\u306F\u30ED\u30B0\u30A4\u30F3ID\u3092\u5165\u529B\u3057\u307E\u3059...",
        selectedOption: selectedOption,
        value: this.state.searchInput
      }, this.state.searchResult.map(function (person) {
        return _react.default.createElement("option", {
          // eslint-disable-next-line react/jsx-no-literals
          "data-automation": "sdk-item-bank-acoption-user-".concat(person.uuid),
          value: person.uuid,
          key: person.uuid
        }, person.fullName);
      }));
    }
  }]);
  AsyncSearch.displayName = "AsyncSearch";
  return AsyncSearch;
}(_react.Component);

exports.default = AsyncSearch;
AsyncSearch.propTypes = {
  debounceDelay: _propTypes.default.number,
  minChars: _propTypes.default.number,
  onSelectionChange: _propTypes.default.func.isRequired,
  search: _propTypes.default.func.isRequired,
  selectedOption: _propTypes.default.arrayOf(_propTypes.default.shape({
    avatar: _propTypes.default.string,
    fullName: _propTypes.default.string.isRequired,
    uuid: _propTypes.default.string.isRequired
  })).isRequired,
  selectionFilter: _propTypes.default.func
};
AsyncSearch.defaultProps = {
  debounceDelay: 500,
  minChars: 1,
  selectionFilter: function selectionFilter(value) {
    return value;
  }
};