"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _Button = _interopRequireDefault(require("@instructure/ui-buttons/lib/components/Button"));

var _CloseButton = _interopRequireDefault(require("@instructure/ui-buttons/lib/components/CloseButton"));

var _Heading = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Heading"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _constants = require("@instructure/quiz-common/lib/constants");

var _Modal = _interopRequireWildcard(require("@instructure/quiz-common/lib/components/Modal"));

var MoveImmutableModal =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(MoveImmutableModal, _Component);

  function MoveImmutableModal() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, MoveImmutableModal);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(MoveImmutableModal)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.handleSubmit = function (e) {
      var _this$props = _this.props,
          quizId = _this$props.quizId,
          position = _this$props.position,
          stimulusQuizEntryId = _this$props.stimulusQuizEntryId,
          quizEntry = _this$props.quizEntry;

      _this.props.closeModal();

      _this.props.setUI(_constants.MOVED_IN_SIDEBAR, _this.props.movedInSidebar);

      _this.props.moveImmutableQuizEntry(quizId, position, stimulusQuizEntryId, quizEntry.id);
    };

    _this.closeAction = function () {
      _this.props.closeModal();
    };

    return _this;
  }

  (0, _createClass2.default)(MoveImmutableModal, [{
    key: "cancelButton",
    value: function cancelButton() {
      return _react.default.createElement(_Button.default, {
        onClick: this.closeAction,
        margin: _constants.XSMALL_SIDE_MARGIN
      }, "\u30AD\u30E3\u30F3\u30BB\u30EB");
    }
  }, {
    key: "doneButton",
    value: function doneButton() {
      return _react.default.createElement(_Button.default, {
        variant: "primary",
        onClick: this.handleSubmit,
        margin: _constants.XSMALL_SIDE_MARGIN
      }, "\u30AF\u30ED\u30FC\u30F3\u3092\u4F5C\u6210\u3057\u3066\u79FB\u52D5");
    }
  }, {
    key: "renderBody",
    value: function renderBody() {
      return _react.default.createElement("div", null, "\u751F\u5F92\u306F\u65E2\u306B\u305D\u308C\u306B\u56DE\u7B54\u3092\u958B\u59CB\u3057\u3066\u3044\u308B\u305F\u3081\u3001\u3053\u306E\u4F4D\u7F6E\u306B\u79FB\u52D5\u3059\u308B\u3053\u3068\u3067\u3001\u8CEA\u554F\u304C\u30AF\u30ED\u30FC\u30CB\u30F3\u30B0\u3055\u308C\u3001\u95A2\u9023\u3059\u308B\u523A\u6FC0\u3092\u5909\u66F4\u3057\u307E\u3059\u3002");
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(_Modal.default, {
        open: this.props.modalOpen,
        onDismiss: this.closeAction,
        size: "small",
        label: "\u30AF\u30ED\u30FC\u30F3\u3092\u78BA\u8A8D\u3057\u3066\u79FB\u52D5"
      }, _react.default.createElement(_Modal.ModalHeader, null, _react.default.createElement(_Heading.default, {
        level: "reset",
        as: "h2"
      }, "\u30AF\u30ED\u30FC\u30F3\u3092\u78BA\u8A8D\u3057\u3066\u79FB\u52D5"), _react.default.createElement(_CloseButton.default, {
        onClick: this.closeAction,
        placement: "end",
        offset: "medium",
        variant: "icon"
      }, "\u9589\u3058\u308B")), _react.default.createElement(_Modal.ModalBody, null, _react.default.createElement(_Text.default, null, this.renderBody())), _react.default.createElement(_Modal.ModalFooter, null, this.cancelButton(), this.doneButton()));
    }
  }]);
  MoveImmutableModal.displayName = "MoveImmutableModal";
  return MoveImmutableModal;
}(_react.Component);

exports.default = MoveImmutableModal;
MoveImmutableModal.propTypes = {
  closeModal: _propTypes.default.func.isRequired,
  modalOpen: _propTypes.default.bool.isRequired,
  moveImmutableQuizEntry: _propTypes.default.func.isRequired,
  movedInSidebar: _propTypes.default.bool,
  position: _propTypes.default.number,
  quizEntry: _reactImmutableProptypes.default.record,
  quizId: _propTypes.default.string,
  setUI: _propTypes.default.func.isRequired,
  stimulusQuizEntryId: _propTypes.default.string
};
MoveImmutableModal.defaultProps = {
  movedInSidebar: false,
  position: void 0,
  quizEntry: void 0,
  quizId: void 0,
  stimulusQuizEntryId: void 0
};