"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _immutable = require("immutable");

var _Select = _interopRequireDefault(require("@instructure/ui-forms/lib/components/Select"));

var _passthroughProps = require("@instructure/ui-utils/lib/react/passthroughProps");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _constants = require("@instructure/quiz-common/lib/constants");

var _instUIMessages = require("../../../util/instUIMessages");

var BankSelection =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(BankSelection, _Component);

  function BankSelection() {
    (0, _classCallCheck2.default)(this, BankSelection);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(BankSelection).apply(this, arguments));
  }

  (0, _createClass2.default)(BankSelection, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this = this;

      return this.props.getAllBanks().then(function (bankIds) {
        return _this.props.setUi(_constants.SELECT_BANKS_OPTIONS, (0, _immutable.List)(bankIds));
      });
    }
  }, {
    key: "renderOptions",
    value: function renderOptions() {
      return this.props.banks.toArray().map(function (bank) {
        return _react.default.createElement("option", {
          key: bank.id,
          value: bank.id
        }, bank.title);
      });
    }
  }, {
    key: "getErrors",
    value: function getErrors() {
      var selectedBank = this.props.selectedBank;

      if (selectedBank && selectedBank.archived) {
        return (0, _instUIMessages.toErrors)(["\u3053\u306E\u30A2\u30A4\u30C6\u30E0\u30D0\u30F3\u30AF \"" + selectedBank.title + "\"\u306F\u3082\u3046\u5B58\u5728\u3057\u3066\u3044\u307E\u305B\u3093\u3002\u6709\u52B9\u306A\u30D0\u30F3\u30AF\u3092\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044\u3002"]);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          selectedBank = _this$props.selectedBank,
          label = _this$props.label;
      var selectedOption = {
        label: ''
      };

      if (selectedBank && !selectedBank.archived) {
        selectedOption.value = selectedBank.id;
        selectedOption.label = selectedBank.title;
      }

      return _react.default.createElement(_Select.default, Object.assign({}, (0, _passthroughProps.omitProps)(this.props, BankSelection.propTypes), {
        editable: true,
        selectedOption: selectedOption,
        label: label || "\u76EE\u7684\u5730\u30D0\u30F3\u30AF\u3092\u9078\u629E\u3057\u3066\u304F\u3060\u3055\u3044",
        onChange: this.props.onBankSelection,
        "data-automation": "sdk-item-bank-modal",
        messages: this.getErrors()
      }), this.renderOptions());
    }
  }]);
  BankSelection.displayName = "BankSelection";
  return BankSelection;
}(_react.Component);

exports.default = BankSelection;
BankSelection.propTypes = {
  banks: _reactImmutableProptypes.default.list.isRequired,
  getAllBanks: _propTypes.default.func.isRequired,
  label: _propTypes.default.string,
  onBankSelection: _propTypes.default.func,
  selectedBank: _reactImmutableProptypes.default.record,
  setUi: _propTypes.default.func.isRequired
};
BankSelection.defaultProps = {
  label: null,
  onBankSelection: function onBankSelection() {},
  selectedBank: null
};