"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.interactionTypeMetadata = void 0;

var _IconPlus = _interopRequireDefault(require("@instructure/ui-icons/lib/Line/IconPlus"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

// TODO: Add correct icon file imports when they are in inst icons
// import MultipleChoiceIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MultipleAnswerIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import TrueOrFalseIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MatchingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import OrderingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import FillBlankIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import EssayIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
var interactionTypesIconDictionary = function interactionTypesIconDictionary(intType) {
  return {// TODO: Uncomment when we have the icons imported
    // 'choice': MultipleChoiceIcon,
    // 'multi-answer': MultipleAnswerIcon,
    // 'true-false': TrueOrFalseIcon,
    // 'matching': MatchingIcon,
    // 'ordering': OrderingIcon,
    // 'fill-blank': FillBlankIcon,
    // 'essay': EssayIcon
  }[intType.slug] || _IconPlus.default;
};

var interactionTypesNameDictionary = function interactionTypesNameDictionary(intType) {
  return {
    categorization: "\u30AB\u30C6\u30B4\u30EA\u5316",
    choice: "\u8907\u6570\u9078\u629E\u80A2",
    essay: "\u30A8\u30C3\u30BB\u30A4\uFF08\u5C0F\u8AD6\u6587\uFF09",
    'file-upload': "\u30D5\u30A1\u30A4\u30EB\u306E\u30A2\u30C3\u30D7\u30ED\u30FC\u30C9",
    'fill-blank': "\u7A7A\u6B04\u3092\u57CB\u3081\u308B",
    formula: "\u6570\u5F0F",
    'hot-spot': "\u30DB\u30C3\u30C8\u30B9\u30DD\u30C3\u30C8",
    matching: "\u6574\u5408",
    'multi-answer': "\u8907\u6570\u306E\u89E3\u7B54",
    numeric: "\u6570\u5024",
    ordering: "\u30AA\u30FC\u30C0\u30FC\u4E2D",
    'true-false': "\u6B63\u8AA4\uFF08\u25CB\xD7\uFF09"
  }[intType.slug] || intType.name;
};

var interactionTypeMetadata = function interactionTypeMetadata(intType) {
  return {
    icon: interactionTypesIconDictionary(intType),
    name: interactionTypesNameDictionary(intType)
  };
};

exports.interactionTypeMetadata = interactionTypeMetadata;