"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _IconTrash = _interopRequireDefault(require("@instructure/ui-icons/lib/Line/IconTrash"));

var _IconReset = _interopRequireDefault(require("@instructure/ui-icons/lib/Line/IconReset"));

var _Button = _interopRequireDefault(require("@instructure/ui-buttons/lib/components/Button"));

var _Select = _interopRequireDefault(require("@instructure/ui-forms/lib/components/Select"));

var _ScreenReaderContent = _interopRequireDefault(require("@instructure/ui-a11y/lib/components/ScreenReaderContent"));

var _Grid = _interopRequireWildcard(require("@instructure/ui-layout/lib/components/Grid"));

var _View = _interopRequireDefault(require("@instructure/ui-layout/lib/components/View"));

var _Avatar = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Avatar"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _constants = require("@instructure/quiz-common/lib/constants");

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var styles = {
  componentId: 'edByO',
  template: function template(theme) {
    return "\n\n.edByO_bqPU{text-decoration:line-through}";
  },
  'labelRemoved': 'edByO_bqPU'
};

var PeopleList =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(PeopleList, _Component);

  function PeopleList() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, PeopleList);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(PeopleList)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.removeButton = function (person, isPersonRemoved) {
      return _react.default.createElement(_Button.default // eslint-disable-next-line react/jsx-no-literals
      , {
        "data-automation": "sdk-unshare-bank-user-".concat(person.get('userUuid')),
        variant: "icon",
        onClick: function onClick() {
          return _this.props.onPersonRemove(person.get('id'), isPersonRemoved);
        },
        icon: isPersonRemoved ? _IconReset.default : _IconTrash.default
      }, _react.default.createElement(_ScreenReaderContent.default, null, isPersonRemoved ? "\u041E\u0442\u043C\u0435\u043D\u0438\u0442\u044C \u0443\u0434\u0430\u043B\u0435\u043D\u0438\u0435 \u0434\u043B\u044F " + person.get('fullName') : "\u0423\u0434\u0430\u043B\u0438\u0442\u044C " + person.get('fullName')));
    };

    _this.renderPerson = function (person, index) {
      var isPersonRemoved = _this.props.peopleToRemove.includes(person.get('id'));

      return _react.default.createElement(_Grid.GridRow, {
        key: person.get('userUuid'),
        "data-automation": "sdk-shared-with-user-row"
      }, _react.default.createElement(_Grid.GridCol, {
        width: 1
      }, _react.default.createElement(_Avatar.default, {
        name: person.get('fullName'),
        src: person.get('avatar'),
        size: "small"
      })), _react.default.createElement(_Grid.GridCol, null, _react.default.createElement("span", {
        className: isPersonRemoved && styles.labelRemoved,
        "data-automation": isPersonRemoved && "sdk-shared-user-removed"
      }, person.get('fullName'))), false && _react.default.createElement(_Grid.GridCol, {
        width: "auto"
      }, _react.default.createElement(_Select.default, {
        onChange: function onChange(event) {
          return _this.props.onPermissionChange(index, event.target.value);
        },
        value: person.get('permission'),
        label: _react.default.createElement(_ScreenReaderContent.default, null, "\u0414\u043E\u0441\u0442\u0443\u043F \u0434\u043B\u044F " + person.get('fullName'))
      }, _react.default.createElement("option", {
        value: _constants.CAN_EDIT
      }, "\u0420\u0435\u0434\u0430\u043A\u0442\u0438\u0440\u043E\u0432\u0430\u043D\u0438\u0435 \u0432\u043E\u0437\u043C\u043E\u0436\u043D\u043E"), _react.default.createElement("option", {
        value: _constants.READ_ONLY
      }, "\u0422\u043E\u043B\u044C\u043A\u043E \u0434\u043B\u044F \u0447\u0442\u0435\u043D\u0438\u044F"))), _react.default.createElement(_Grid.GridCol, {
        width: "auto"
      }, _this.props.people.size === 1 ? null : _this.removeButton(person, isPersonRemoved)));
    };

    return _this;
  }

  (0, _createClass2.default)(PeopleList, [{
    key: "render",
    value: function render() {
      var people = this.props.people;
      this.removeButtonRefs = [];
      return _react.default.createElement("div", null, _react.default.createElement(_Text.default, {
        as: "div",
        weight: "bold"
      }, "\u0412 \u043D\u0430\u0441\u0442\u043E\u044F\u0449\u0435\u0435 \u0432\u0440\u0435\u043C\u044F \u0432 \u043E\u0431\u0449\u0435\u043C \u0434\u043E\u0441\u0442\u0443\u043F\u0435 \u0441"), _react.default.createElement(_View.default, {
        as: "div",
        padding: "small 0 0 0",
        "data-automation": "sdk-shared-bank-user-list"
      }, _react.default.createElement(_Grid.default, {
        vAlign: "middle"
      }, people.map(this.renderPerson))));
    }
  }]);
  PeopleList.displayName = "PeopleList";
  return PeopleList;
}(_react.Component);

exports.default = PeopleList;
PeopleList.propTypes = {
  people: _propTypes.default.arrayOf(_propTypes.default.shape({
    avatar: _propTypes.default.string,
    fullName: _propTypes.default.string.isRequired,
    userUuid: _propTypes.default.string.isRequired,
    permission: _propTypes.default.string.isRequired
  })).isRequired,
  onPermissionChange: _propTypes.default.func.isRequired,
  onPersonRemove: _propTypes.default.func.isRequired,
  peopleToRemove: _propTypes.default.arrayOf(_propTypes.default.string).isRequired
};