"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.propsForInteractionShow = exports.propsForInteractionEdit = void 0;

var _RichContentInput = _interopRequireDefault(require("../components/RichContentInput"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var propsForInteractionEdit = function propsForInteractionEdit(props, additionalOptions) {
  var item = props.workingItem.toJS();

  var changeItemState = function changeItemState(newState) {
    props.changeItemState(item.id, newState);
  };

  var mediaUpload = function mediaUpload(file, callback) {
    var onUploadError = function onUploadError() {
      props.addError("\u041F\u0440\u043E\u0438\u0437\u043E\u0448\u043B\u0430 \u043E\u0448\u0438\u0431\u043A\u0430 \u043F\u0440\u0438 \u043E\u0442\u043F\u0440\u0430\u0432\u043A\u0435 \u0432\u0430\u0448\u0435\u0433\u043E \u0444\u0430\u0439\u043B\u0430.");
    };

    props.interactionFileUpload(props.parentType, props.parentId, file, callback, onUploadError);
  };

  var onModalOpen = function onModalOpen() {
    props.occludeQuizEntries(true);
  };

  var onModalClose = function onModalClose() {
    props.occludeQuizEntries(false);
  };

  var setOneQuestionAtATime = function setOneQuestionAtATime(event) {
    return props.setOneQuestionAtATime(props.quizId, event.target.checked);
  };

  return {
    additionalOptions: additionalOptions,
    appContainer: props.appContainer,
    changeItemState: changeItemState,
    errors: props.workingItem.getErrors().toJS(),
    errorsAreShowing: props.errorsAreShowing,
    hiddenOptions: {
      calculator: !props.showCalculator
    },
    interactionData: item.interactionData,
    // SHIM: canvas-rce breaks on null values now
    // this is a shim until canvas-rce deals with
    // null values better
    itemBody: item.itemBody || '',
    itemId: item.id,
    mediaUpload: mediaUpload,
    notifyScreenreader: props.screenreaderNotification,
    onModalOpen: onModalOpen,
    onModalClose: onModalClose,
    oneQuestionAtATime: props.oneQuestionAtATime,
    openImportModal: props.openImportModal,
    pointsChange: props.handleQuizEntryPointsChange,
    properties: item.properties,
    override: props.override,
    overrideEditableForItem: props.overrideEditableForItem,
    overrideEditableForRegrading: props.overrideEditableForRegrading,
    richContentEditor: _RichContentInput.default,
    scoringData: item.scoringData,
    setOneQuestionAtATime: setOneQuestionAtATime,
    stemErrors: props.workingItem.errorsFor('itemBody').toJS(),
    initialFocusId: props.initialFocusId,
    calculatorType: item.calculatorType
  };
};

exports.propsForInteractionEdit = propsForInteractionEdit;

var propsForInteractionShow = function propsForInteractionShow(item) {
  return {
    itemId: item.id,
    interactionData: item.interactionData,
    // SHIM: canvas-rce breaks on null values now
    // this is a shim until canvas-rce deals with
    // null values better
    itemBody: item.itemBody || '',
    properties: item.properties,
    notifyScreenreader: true,
    scoringData: item.scoringData
  };
};

exports.propsForInteractionShow = propsForInteractionShow;