"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatTime = formatTime;
exports.formatTimespan = void 0;

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _default_sl_number = Intl.NumberFormat("sl", { style: "decimal" }).format;
var minuteDuration = 60;
var hourDuration = 3600;

var formatHours = function formatHours(hours) {
  var _s, _n, _v, _i;

  return _s = hours, _n = +_s, (_v = (_s + '.').split('.')[1].length, _i = Math.floor(Math.abs(+_s)), _v === 0 && _i % 100 === 1 ? _default_sl_number(hours) + " ura" : _default_sl_number(hours) + " ur");
};

var formatMinutes = function formatMinutes(minutes) {
  var _s2, _n2, _v2, _i2;

  return _s2 = minutes, _n2 = +_s2, (_v2 = (_s2 + '.').split('.')[1].length, _i2 = Math.floor(Math.abs(+_s2)), _v2 === 0 && _i2 % 100 === 1 ? _default_sl_number(minutes) + " minuta" : _default_sl_number(minutes) + " minut");
};

var formatSeconds = function formatSeconds(seconds) {
  var _s3, _n3, _v3, _i3;

  return _s3 = seconds, _n3 = +_s3, (_v3 = (_s3 + '.').split('.')[1].length, _i3 = Math.floor(Math.abs(+_s3)), _v3 === 0 && _i3 % 100 === 1 ? _default_sl_number(seconds) + " sekunda" : _default_sl_number(seconds) + " sekund");
};

var formatTimespan = function formatTimespan(startTime, endTime) {
  return formatTime(endTime - startTime, 1000);
};

exports.formatTimespan = formatTimespan;

function formatTime(time) {
  var secondDuration = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : 1;
  var totalSeconds = Math.floor(time / secondDuration);
  var parts = [];
  var hours = Math.floor(totalSeconds / hourDuration);

  if (hours !== 0) {
    parts.push(formatHours(hours));
  }

  var minutes = Math.floor(totalSeconds / minuteDuration) % minuteDuration;

  if (minutes !== 0) {
    parts.push(formatMinutes(minutes));
  }

  var seconds = totalSeconds % minuteDuration;

  if (seconds !== 0 || parts.length === 0) {
    parts.push(formatSeconds(seconds));
  }

  var separator = " ";
  return parts.join(separator);
}