"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.interactionTypeMetadata = void 0;

var _IconPlus = _interopRequireDefault(require("@instructure/ui-icons/lib/Line/IconPlus"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

// TODO: Add correct icon file imports when they are in inst icons
// import MultipleChoiceIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MultipleAnswerIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import TrueOrFalseIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import MatchingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import OrderingIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import FillBlankIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
// import EssayIcon from '@instructure/ui-icons/lib/Line/<insert icon name here>'
var interactionTypesIconDictionary = function interactionTypesIconDictionary(intType) {
  return {// TODO: Uncomment when we have the icons imported
    // 'choice': MultipleChoiceIcon,
    // 'multi-answer': MultipleAnswerIcon,
    // 'true-false': TrueOrFalseIcon,
    // 'matching': MatchingIcon,
    // 'ordering': OrderingIcon,
    // 'fill-blank': FillBlankIcon,
    // 'essay': EssayIcon
  }[intType.slug] || _IconPlus.default;
};

var interactionTypesNameDictionary = function interactionTypesNameDictionary(intType) {
  return {
    categorization: "Kategorizacija",
    choice: "Ve\u010D izborov",
    essay: "Esej",
    'file-upload': "Nalaganje datotek",
    'fill-blank': "Izpolni manjkajo\u010De odgovore",
    formula: "Obrazec",
    'hot-spot': "\u017Dari\u0161\u010Dno obmo\u010Dje",
    matching: "Ujemanje",
    'multi-answer': "Odgovor z ve\u010D mo\u017Enostmi",
    numeric: "\u0160tevil\u010Dno",
    ordering: "Vrstni red razvr\u0161\u010Danja",
    'true-false': "Resni\u010Dno ali neresni\u010Dno"
  }[intType.slug] || intType.name;
};

var interactionTypeMetadata = function interactionTypeMetadata(intType) {
  return {
    icon: interactionTypesIconDictionary(intType),
    name: interactionTypesNameDictionary(intType)
  };
};

exports.interactionTypeMetadata = interactionTypeMetadata;