"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf3 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactImmutableProptypes = _interopRequireDefault(require("react-immutable-proptypes"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Alert = _interopRequireDefault(require("@instructure/ui-alerts/lib/components/Alert"));

var _Text = _interopRequireDefault(require("@instructure/ui-elements/lib/components/Text"));

var _View = _interopRequireDefault(require("@instructure/ui-layout/lib/components/View"));

var _PresentationContent = _interopRequireDefault(require("@instructure/ui-a11y/lib/components/PresentationContent"));

var _lib = _interopRequireDefault(require("@instructure/ui-themeable/lib"));

var _RichContentRenderer = _interopRequireDefault(require("@instructure/quiz-rce/lib/components/RichContentRenderer"));

var _formatMessage = _interopRequireDefault(require("@instructure/quiz-i18n/lib/format-message"));

var _PositionBox = _interopRequireDefault(require("../../positionBox/PositionBox"));

var _constants = require("@instructure/quiz-common/lib/constants");

var _componentForItem = _interopRequireDefault(require("../../../../util/componentForItem"));

var _CustomPropTypes = _interopRequireDefault(require("../../../../util/CustomPropTypes"));

var _keyboardClickable = _interopRequireDefault(require("../../../../util/keyboardClickable"));

var _theme = _interopRequireDefault(require("./theme"));

var _dec,
    _class,
    _class2,
    _temp,
    _default_zhHans_number = Intl.NumberFormat("zh-Hans", { style: "decimal" }).format;

var styles = {
  componentId: 'eIOvL',
  template: function template(theme) {
    return "\n\n.eIOvL_bvdE{padding:".concat(theme.sessionItemResultPadding || 'inherit', "}\n\n.eIOvL_ebwZ{border-top:solid ").concat(theme.topBorderWidth || 'inherit', " ").concat(theme.topBorderColor || 'inherit', "}\n\n.eIOvL_czRh{margin:").concat(theme.resultMargin || 'inherit', "}\n\n.eIOvL_cwte{color:").concat(theme.pointsColor || 'inherit', ";font-size:").concat(theme.pointFontSize || 'inherit', "}\n\n.eIOvL_cSuF{font-size:").concat(theme.questionFontSize || 'inherit', "}\n\n.eIOvL_fqsT{align-items:center;display:flex}\n\n.eIOvL_cgkp{background-color:").concat(theme.itemFeedbackWrapperBackgroundColor || 'inherit', ";border-radius:").concat(theme.itemFeedbackWrapperBorderRadius || 'inherit', ";font-size:").concat(theme.itemFeedbackWrapperFontSize || 'inherit', ";margin-top:").concat(theme.itemFeedbackWrapperMargin || 'inherit', ";padding:").concat(theme.itemFeedbackWrapperPadding || 'inherit', ";white-space:pre-wrap}\n\n.eIOvL_couS{color:").concat(theme.itemFeedbackLabelColor || 'inherit', ";font-size:").concat(theme.itemFeedbackLabelFontSize || 'inherit', ";margin-bottom:").concat(theme.itemFeedbackMargin || 'inherit', "}\n\n.eIOvL_bcAI{margin-top:").concat(theme.itemFeedbackTextMargin || 'inherit', "}");
  },
  'sessionItemResult': 'eIOvL_bvdE',
  'topBorder': 'eIOvL_ebwZ',
  'result': 'eIOvL_czRh',
  'points': 'eIOvL_cwte',
  'question': 'eIOvL_cSuF',
  'sessionItemResultHeader': 'eIOvL_fqsT',
  'itemFeedbackWrapper': 'eIOvL_cgkp',
  'itemFeedbackLabel': 'eIOvL_couS',
  'itemFeedbackText': 'eIOvL_bcAI'
};
var SessionItemResult = (_dec = (0, _lib.default)(_theme.default, styles), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(SessionItemResult, _Component);

  function SessionItemResult() {
    var _getPrototypeOf2;

    var _this;

    (0, _classCallCheck2.default)(this, SessionItemResult);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = (0, _possibleConstructorReturn2.default)(this, (_getPrototypeOf2 = (0, _getPrototypeOf3.default)(SessionItemResult)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _this.getWorkingInstance = function (sessionItemResult) {
      // Check for getWorkingInstance because it does not exist on results page object
      // and is only needed on the grading page
      if (sessionItemResult.getWorkingInstance) {
        return sessionItemResult.getWorkingInstance().toJS();
      }

      return sessionItemResult.toJS();
    };

    return _this;
  }

  (0, _createClass2.default)(SessionItemResult, [{
    key: "position",
    value: function position() {
      return this.props.sessionItem.position;
    }
  }, {
    key: "regraded",
    value: function regraded() {
      return this.props.sessionItemResult.regradeInfo && this.props.sessionItemResult.regradeInfo.get('regraded');
    }
  }, {
    key: "renderAlert",
    value: function renderAlert() {
      return _react.default.createElement(_Alert.default, {
        variant: "warning",
        margin: "medium"
      }, _react.default.createElement(_PresentationContent.default, null, "\u6B64\u95EE\u9898\u5DF2\u91CD\u65B0\u8BA1\u5206\u3002"));
    }
  }, {
    key: "renderRegradePoints",
    value: function renderRegradePoints() {
      var _s, _n, _s2, _n2;

      return _react.default.createElement("div", null, _react.default.createElement(_View.default, {
        as: "span",
        size: "small",
        margin: "small"
      }, _react.default.createElement(_Text.default, {
        color: "secondary"
      }, "\u539F\u6765\u7684\u5F97\u5206" + (_default_zhHans_number(this.props.sessionItemResult.regradeInfo.get('originalScore') || 0) + " / " + _default_zhHans_number(this.props.sessionItemResult.regradeInfo.get('originalPointsPossible')) + "\u5206"))), _react.default.createElement(_View.default, {
        as: "span",
        size: "small",
        margin: "small"
      }, _react.default.createElement(_Text.default, {
        color: "warning"
      }, "\u91CD\u65B0\u8BA1\u5206\u5206\u6570" + (_default_zhHans_number(this.props.sessionItemResult.regradeInfo.get('newScore') || 0) + " / " + _default_zhHans_number(this.props.sessionItemResult.regradeInfo.get('newPointsPossible')) + "\u5206"))));
    }
  }, {
    key: "renderHeader",
    value: function renderHeader() {
      return _react.default.createElement("div", {
        className: styles.sessionItemResultHeader
      }, this.renderResultPosition(), this.regraded() ? this.renderRegradePoints() : this.renderPoints());
    }
  }, {
    key: "renderResultPosition",
    value: function renderResultPosition() {
      var position = this.position();
      var positionText;

      if (this.regraded()) {
        positionText = "\u9879\u76EE" + _default_zhHans_number(position) + "\u7684\u7ED3\u679C\u3002\u6B64\u95EE\u9898\u5DF2\u91CD\u65B0\u8BA1\u5206\u3002";
      } else {
        positionText = "\u9879\u76EE" + _default_zhHans_number(position) + "\u7684\u7ED3\u679C\u3002";
      }

      return _react.default.createElement(_PositionBox.default, {
        position: position,
        headingLevel: "h3",
        headingText: positionText
      });
    }
  }, {
    key: "renderPoints",
    value: function renderPoints() {
      return _react.default.createElement("div", {
        className: styles.points
      }, this.pointsDisplayText);
    }
  }, {
    key: "renderFeedbackBox",
    value: function renderFeedbackBox(feedbackContent, formattedFeedbackTitle) {
      if (feedbackContent) {
        return _react.default.createElement("div", {
          className: styles.itemFeedbackWrapper
        }, _react.default.createElement("div", {
          className: styles.itemFeedbackLabel
        }, formattedFeedbackTitle), _react.default.createElement(_RichContentRenderer.default, {
          customStyles: styles.itemFeedbackText,
          content: feedbackContent
        }));
      }
    }
  }, {
    key: "renderItemFeedback",
    value: function renderItemFeedback(simpleSessionItemResult) {
      var itemFeedback = simpleSessionItemResult.feedback && simpleSessionItemResult.feedback.itemFeedback || {};
      var correctFeedback = this.renderFeedbackBox(itemFeedback.correct, "\u6B63\u786E\u7684\u53CD\u9988");
      var incorrectFeedback = this.renderFeedbackBox(itemFeedback.incorrect, "\u4E0D\u6B63\u786E\u7684\u53CD\u9988");
      var neutralFeedback = this.renderFeedbackBox(itemFeedback.neutral, "\u4E00\u822C\u53CD\u9988");

      if (correctFeedback || incorrectFeedback || neutralFeedback) {
        return _react.default.createElement("div", null, correctFeedback, incorrectFeedback, neutralFeedback);
      }
    }
  }, {
    key: "renderGraderFeedback",
    value: function renderGraderFeedback(simpleSessionItemResult) {
      var graderFeedback = simpleSessionItemResult.feedback && simpleSessionItemResult.feedback.graderFeedback || {};

      if (!this.props.hideGraderFeedback && graderFeedback.content) {
        if (this.props.editGraderFeedback) {
          return _react.default.createElement("div", {
            role: "button",
            onClick: this.props.editGraderFeedback,
            onKeyDown: _keyboardClickable.default,
            className: styles.itemFeedbackWrapper,
            tabIndex: "0"
          }, _react.default.createElement("div", {
            className: styles.itemFeedbackLabel
          }, "\u8BC4\u5206\u4EBA\u53CD\u9988"), _react.default.createElement(_RichContentRenderer.default, {
            customStyles: styles.itemFeedbackText,
            content: graderFeedback.content
          }));
        } else {
          return this.renderFeedbackBox(graderFeedback.content, "\u8BC4\u5206\u4EBA\u53CD\u9988");
        }
      }
    }
  }, {
    key: "renderSessionItemResult",
    value: function renderSessionItemResult() {
      var _this$props = this.props,
          appContainer = _this$props.appContainer,
          sessionItem = _this$props.sessionItem,
          sessionItemResult = _this$props.sessionItemResult,
          itemResultsModifications = _this$props.itemResultsModifications;

      if (!sessionItemResult.isLoaded()) {
        return null;
      }

      var item = sessionItem.getItem();
      var slug = item.getInteractionType && item.getInteractionType().slug;
      var ResultInteraction = (0, _componentForItem.default)(slug, _constants.COMPONENT_RESULT);
      var simpleItem = item.toJS();
      var simpleResultsModifications = itemResultsModifications && itemResultsModifications.toJS() || {};
      var simpleSessionItem = sessionItem.toJS();
      var simpleSessionItemResult = sessionItemResult.toJS();
      return _react.default.createElement("div", {
        className: styles.result
      }, _react.default.createElement("div", {
        className: styles.question
      }, _react.default.createElement(ResultInteraction, {
        appContainer: appContainer,
        itemBody: simpleItem.itemBody,
        itemId: simpleSessionItem.id // needed for input group name
        ,
        interactionData: simpleItem.interactionData,
        properties: simpleItem.properties || {},
        scoringData: simpleSessionItem.scoringData,
        scoredData: simpleSessionItemResult.scoredData,
        itemResultsModifications: simpleResultsModifications[simpleSessionItem.id]
      })), this.renderItemFeedback(simpleSessionItemResult), this.renderGraderFeedback(this.getWorkingInstance(sessionItemResult)));
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames;

      var classes = (0, _classnames.default)((_classNames = {}, (0, _defineProperty2.default)(_classNames, styles.sessionItemResult, true), (0, _defineProperty2.default)(_classNames, styles.topBorder, this.props.shouldRenderTopBorder), _classNames));
      return _react.default.createElement("div", {
        className: classes
      }, this.regraded() ? this.renderAlert() : null, this.renderHeader(), this.renderSessionItemResult());
    }
  }, {
    key: "points",
    get: function get() {
      var sessionItemResult = this.props.sessionItemResult;
      var normalizedSessionItemResult = sessionItemResult && sessionItemResult.toJS() || {};
      return normalizedSessionItemResult.score;
    }
  }, {
    key: "pointsPresent",
    get: function get() {
      return typeof this.points === 'number';
    }
  }, {
    key: "pointsPossible",
    get: function get() {
      return this.props.sessionItem.pointsPossible;
    }
  }, {
    key: "pointsPossiblePresent",
    get: function get() {
      return typeof this.pointsPossible === 'number';
    }
  }, {
    key: "pointsDisplayText",
    get: function get() {
      var points = this.points;
      var possible = this.pointsPossible;

      if (this.pointsPresent && this.pointsPossiblePresent) {
        var _s3, _n3;

        return _default_zhHans_number(points) + " / " + _default_zhHans_number(possible) + "\u5206";
      }

      if (this.pointsPossiblePresent) {
        var _s4, _n4;

        return _default_zhHans_number(possible) + "\u5206" + "\u6EE1\u5206";
      }

      if (this.pointsPresent) {
        var _s5, _n5;

        return _default_zhHans_number(points) + "\u5206" + "\u5F97\u5206";
      }

      return '';
    }
  }]);
  SessionItemResult.displayName = "SessionItemResult";
  return SessionItemResult;
}(_react.Component), _class2.propTypes = {
  appContainer: _CustomPropTypes.default.selectors.isRequired,
  editGraderFeedback: _propTypes.default.func,
  hideGraderFeedback: _propTypes.default.bool,
  itemResultsModifications: _reactImmutableProptypes.default.map,
  sessionItem: _reactImmutableProptypes.default.record.isRequired,
  sessionItemResult: _reactImmutableProptypes.default.record.isRequired,
  shouldRenderTopBorder: _propTypes.default.bool
}, _class2.defaultProps = {
  editGraderFeedback: null,
  hideGraderFeedback: false,
  itemResultsModifications: null,
  shouldRenderTopBorder: true
}, _temp)) || _class);
exports.default = SessionItemResult;